<template>
  <div>
    <b-container>
      <b-row>
        <b-col cols="6">
          <b-form-group id="group_quantity" label="Cantidad" label-for="input_quantity">
            <b-form-input id="input_quantity" v-model="form.quantity" type="text" required></b-form-input>
          </b-form-group>
        </b-col>

        <b-col cols="6">
          <b-form-group id="group_resource" label="Recurso" label-for="input_resource">
            <b-form-select
              id="input_resource"
              v-model="form.resource"
              :options="mappedAvailResources"
            ></b-form-select>
          </b-form-group>
        </b-col>
      </b-row>
      <b-row>
        <b-col cols="6">
          <h5>Propietario</h5>
          <b-button @click="selectOwner">Selecciona</b-button>
          <div>Nombre: {{ $_.get(form, 'owner_object.name') }}</div>
        </b-col>
      </b-row>
    </b-container>
    <b-container class="mt-5">
      <b-row>
        <b-col cols="12" class="d-flex justify-content-end">
          <b-button variant="secondary" @click="$emit('cancel')">Cancelar</b-button>
          <b-button variant="primary" @click="saveForm">Guardar</b-button>
        </b-col>
      </b-row>
    </b-container>

    <b-modal ref="owner_modal" centered size="xl" title="Transportista">
      <PersonList @person-click="onOwnerSelect" :preset_filters="{role: 8}" />
    </b-modal>
  </div>
</template>

<script>
// import Vue from "vue";
import { mapState, mapActions } from "vuex";
import PersonList from "@/components/PersonList.vue";

export default {
  name: "shipping-form",
  components: {
    PersonList
  },
  props: {
    preset_form: {
      type: Object,
      default: undefined
    },
    shipping_mode: {
      type: String,
      default: "normal"
    }
  },
  data() {
    return {
      form: {
        resource: null,
        resource_object: null,
        owner: null,
        owner_object: null,
        quantity: null,
        photo_link: null
      }
    };
  },
  computed: {
    ...mapState({
      availResources: state => state.utils.availResources,
      mappedAvailResources: state => state.utils.mappedAvailResources
    }),
    basic_uri_lc() {
      return "/logistica/middle/person/{person_pk}/inventory/";
    },
    basic_uri_rud() {
      return "/logistica/middle/person/{person_pk}/inventory/{inventory_pk}/";
    }
  },
  created() {},
  mounted() {
    if (!this.availResources) {
      this.LOAD_AVAIL_RESOURCES();
    }
    if (this.preset_form) {
      this.form = Object.assign({}, this.form, this.preset_form);
    }
  },
  methods: {
    ...mapActions({
      LOAD_AVAIL_RESOURCES: "utils/LOAD_AVAIL_RESOURCES"
    }),
    saveForm() {
      let uri = undefined;
      let action = undefined;
      this.form.resource = parseInt(this.form.resource);
      this.form.quantity = parseInt(this.form.quantity);
      if (!this.form.pk) {
        action = this.$fetchpost;
        uri = this.$parseurl(this.basic_uri_lc, {
          person_pk: localStorage.getItem("pk_person")
        });
      } else {
        action = this.$fetchput;
        uri = this.$parseurl(this.basic_uri_rud, {
          person_pk: localStorage.getItem("pk_person"),
          inventory_pk: this.form.pk
        });
      }

      action(uri, {
        body: this.form
      })
        // {"email": "...", "username": "...", "id": 0}
        .then(res => {
          res.json().then(data => {
            if (res.ok) {
              this.$emit("saved", data);
            } else {
              // TODO: mostrar error
            }
          });
        });
    },
    selectOwner() {
      this.$refs.owner_modal.show();
    },
    onOwnerSelect(data) {
      this.form.owner = data.pk;
      this.form.owner_object = data;
      this.$refs.owner_modal.hide();
    }
  }
};
</script>
<style scoped>
</style>
